
#include <stdio.h>
#include "data.h"

#define MAX 10000

Interval sort[MAX];
int sortI;

void printInterval(Interval* p) {
	printf("a = %f, b = %f\n", p->a, p->b);
}

void preorder(Interval* p) {

	if ( p == 0 )
		return;

	preorder(p->left);
	if ( sortI < MAX )
		sort[sortI++] = *p;
	else
		printf("Overflow\n");
	preorder(p->right);
}

void print() {
	int i;

	for ( i = 0; i < sortI; i++ ) {
		printInterval(&sort[i]);
	}
}

int levelCount[MAX];
int level;

void postOrder(Interval* p) {
	if ( p == 0 )
		return;
	levelCount[level]++;
	level++;
	postOrder(p->left);
	postOrder(p->right);
	level--;
}

void treeStats() {
	int i;

	for ( i = 0; i < MAX; i++ )
		levelCount[i] = 0;

	level=0;
	postOrder(root);

	i = 0;
	while ( (i < MAX) && (levelCount[i]>0) )
		printf("%d\n", levelCount[i++]);
}

int process() {
	printf("processing\n");
	treeStats();

	sortI = 0;
	preorder(root);

	print();
	return sortI;
}
